/*

Note to helpers:
Thank you for being willing to look at this. 

The problem is that the Tilt_Dn_Timer does not always count down. It may work five times in a row,
then not work five times in a row.

Another problem is that the Tl_Saf_Timer always reads above zero. It never seems to count down.

Period for both timers is 5 seconds but will be around 30 seconds in production.

Thank you for your kind assistance.


*/


#include "project.h"



int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */

 
    int TDA_Flag=0;
    Tl_Saf_Timer_Enable();
    
    Tilt_Dn_Timer_Enable();
    
    for(;;)
    {
      //  LED_Write(~LED_Read());
      //  CyDelay(100);
        
        while(!Tilt_Up_Read() && Tilt_Lmt_Read() && Auto_Mode_Read())
        {
            Tilt_Valve_Write(0);
            Motor_Write(0);
            TDA_Flag=1;
            CyDelay(50);
        }
        
        if(TDA_Flag)
        {
            Tl_Saf_Timer_Start();
            TDA_Flag=0;
        }
        
        
        if(!Tilt_Up_Read() && !Auto_Mode_Read())
        {
            CyDelay(400); // Debounce delay. Do not remove.
            while(Tilt_Lmt_Read())
            {
                Tilt_Valve_Write(0);
                Motor_Write(0);
                if(!Tilt_Up_Read() || !Tilt_Down_Read() || !Drops_Read()) break; // Emergency stop
                CyDelay(50);
            }
            Tl_Saf_Timer_Start();
        }
        
        if(Tl_Saf_Timer_ReadCounter() >0)
        {
            while(!Tilt_Down_Read() && Auto_Mode_Read())
            {
                Tilt_Valve_Write(0);
                Rls_Valve_Write(0);
                CyDelay(50);
            }    
        }
        
        if(!Tilt_Down_Read() && (Tl_Saf_Timer_ReadCounter() >0)  && !Auto_Mode_Read())
        {
            CyDelay(400); // Debounce delay. Do not remove.
            Tilt_Dn_Timer_Start();
            while(Tilt_Dn_Timer_ReadCounter() >0)
            {
                Tilt_Valve_Write(0);
                Rls_Valve_Write(0);
                if(!Tilt_Up_Read() || !Tilt_Down_Read() || !Drops_Read()) break; // Emergency stop
                CyDelay(50);
            }
        }
        
        while(!Drops_Read())
        {
            Drop_Valve_Write(0);
            Motor_Write(0);
            Tl_Saf_Timer_Start();
        }
      
        
        while(!Ext_Read())
        {
            Ex_Rt_Valve1_Write(0);
            Motor_Write(0);
            Tl_Saf_Timer_Start();
        }
      
        
         while(!Ret_Read())
        {
            Ex_Rt_Valve1_Write(0);
            Rls_Valve_Write(0);
            Tl_Saf_Timer_Start();
        }
     
            Tilt_Valve_Write(1);
            Motor_Write(1);
            Ex_Rt_Valve1_Write(1);
            Rls_Valve_Write(1);
            Drop_Valve_Write(1);
 
          
    }
}

/* [] END OF FILE */
